#ifndef __KDIALOGD_H__
#define __KDIALOGD_H__

#include <kfile.h>
#include <kfiledialog.h>
#include <kdedmodule.h>
#include <kfiledialog.h>
#include <kdirselectdialog.h>
#include "common.h"

class KDialogBase;

class KDialogDFileDialog : public KFileDialog
{
    Q_OBJECT

    public:

    KDialogDFileDialog(Operation op, const QString& startDir, const QString& filter, bool confirmOw);
    virtual ~KDialogDFileDialog();

    public slots:

    void accept();
    void slotOk();

    signals:

    void ok(const QStringList &items);

    private:

    bool itsConfirmOw;
};

class KDialogDDirSelectDialog : public KDirSelectDialog
{
    Q_OBJECT

    public:

    KDialogDDirSelectDialog(const QString& startDir = QString::null,
                            bool localOnly = false,
                            QWidget *parent = 0L,
                            const char *name = 0, bool modal = false)
        : KDirSelectDialog(startDir, localOnly, parent, name, modal) { }

    virtual ~KDialogDDirSelectDialog();

    public slots:

    void slotOk();

    signals:

    void ok(const QStringList &items);
};

class KDialogDClient : public QObject
{
    Q_OBJECT

    public:

    KDialogDClient(int sock, QObject *parent);
    virtual ~KDialogDClient();

    public slots:

    void read();
    void ok(const QStringList &items);
    void finished();

    signals:

    void error(KDialogDClient *);

    private:

    void close();
    void cancel();
    bool readData(QCString &buffer, int size);
    bool readData(char *buffer, int size)        { return readBlock(fd, buffer, size); }
    bool writeData(const char *buffer, int size) { return writeBlock(fd, buffer, size); }
    bool readString(QCString &str);
    bool writeString(const QCString &str);
    void initDialog(const QString &caption, KDialogBase *d, unsigned int xid);

    private:

    int          fd;
    KDialogBase  *dlg;
    bool         accepted;
};

class KDialogD : public QObject
{
    Q_OBJECT

    public:

    KDialogD(QObject *parent=0L);
    virtual ~KDialogD();

    public slots:

    void newConnection();
    void deleteConnection(KDialogDClient *client);

    int fd;
};

class KDialogDKDED : public KDEDModule
{
    Q_OBJECT

    public:

    KDialogDKDED(const QCString &obj);
};

#endif
